
// $.storage = new $.store();

isOffline = /[A-z0-9-_\/\.]*:offline\?(.*)/;
breakParams = /[&=]/;
dots = /\./gi;
dashes = /\//gi;
flags = [ 'Recent', 'Unseen',  'Answered',  'Draft',  'Deleted', 'Flagged' ];

$.ajaxPrefilter(function( options, originalOptions, jqXHR ){

      var offlineAction = isOffline.exec( options.url );

      if( offlineAction )
      {
	  offlineAction = offlineAction[1] || "";
	
	  jqXHR.abort();

	  var params = {};
	  
	  if( offlineAction )
	      offlineAction +=  options.data ? "&" +  options.data : "";

	  offlineAction = offlineAction.split( breakParams );

	  for( var i = 0; i < offlineAction.length; )
	      params[ offlineAction[i++] ] = offlineAction[i++];

	  rest = params["q"].split("/");

	  if( !(rest.length % 2) )
	      var id = rest.pop();

	  var concept = rest.pop();

	  for( var i = 0; i < rest.length; )
	    params[ rest[i++] ] = rest[ i++ ];

	  switch( concept )
	  {
	    case "message":
	    {
		if( id ){
		    var mail = expresso_local_messages.get_local_mail( id );
		    mail.eml = expresso_local_messages.get_src( mail.url_export_file );

		    ( options.success || options.complete )( mail );
		    return;
		}

		var msgs = expresso_local_messages.get_local_range_msgs( params["folder"].replace(dots, "/").replace("local_messages/", ""),
									  params["rows"] * ( params["page"] - 1 ) + 1,
									  params["rows"], "SORTARRIVAL", (params["sord"] == "desc"),
									  "ALL", 1, 1 );

		for( var i = 0; i < msgs.length; i++ )
		{
		      msgs[i].size = msgs[i].Size;
		      msgs[i].timestamp = msgs[i].udate * 1000;
		      msgs[i].flags = [];

		      for( var ii = 0; ii < flags.length; ii++ )
			  if( f = $.trim( msgs[i][ flags[ii] ] ) )
			      msgs[i].flags[ msgs[i].flags.length ] =  f;

		      msgs[i].flags = msgs[i].flags.join(',');
		}

		( options.success || options.complete )( { "rows": msgs, 
							   "records": msgs.length,
							   "page": params["page"], 
							   "total": Math.ceil( msgs.num_msgs / params["rows"] ) } );
	    }
	  }
      }
});

var BASE_PATH = '../prototype/';
//BASE_PATH = '../';
//encontra os pais de todas as pastas e cria uma nova estrutura adicionando os filhos a um array no atributo 'children' do respectivo pai
unorphanize = function(root, element) {
	var ok = false;
	for (var i=0; i<root.length; i++) {
		if (root[i].id == element.parentFolder) {
			element.children = new Array(); 
			root[i].children.push(element);
			return true;
		} else if (ok = unorphanize(root[i].children, element)) {
			break;
		}
	}

	return ok;
}

/* --- helpers --- */
bytes2Size = function(bytes) {
	var sizes = ['B', 'KB', 'MB', 'GB', 'TB'];
	if (bytes == 0) return 'n/a';
	var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
	var size = (i<2) ? Math.round((bytes / Math.pow(1024, i))) : Math.round((bytes / Math.pow(1024, i)) * 100)/100;
	return  size + ' ' + sizes[i];
}

flags2Class = function(cellvalue) {
	var flags_enum = cellvalue.split(',');
	var classes = '';
	for (var i=0; i<flags_enum.length; i++){
		classes += '<span class="icon-'+flags_enum[i].toLowerCase()+'"> </span>';
	}
	return classes;
}

date2Time = function (timestamp) {
	var date = new Date();
	if ((date.getTime() - timestamp) < (24*60*60*1000)) {
		return '<span class="timable" title="'+timestamp+'"> </span>';
	} else {
		date = new Date(timestamp);
		var b = date.toISOString().split("T")[0].split("-");
		var c = b[2] + "/" + b[1] + "/" + b[0];
		return '<span class="datable">' + c + '</span>';
	}
}

changeTabIndex = function (elements) {
//	jQuery('#foldertree').attr('tabIndex', '1').focus();
}


selectedMessagesCount = function() {
	var byte_size = 0, total_messages = 0;
	for (var folder in selectedMessages) {
		for (var message in selectedMessages[folder]) {
			if (selectedMessages[folder][message]) {
				byte_size += parseInt(onceOpenedMessages[folder][message].size);
				total_messages++;
			}
		}
	}
	$("#selected_messages_number").html(total_messages).next().html(bytes2Size(byte_size));

	return total_messages;
}

      function dump(arr,level) {
	      var dumped_text = "";
	      if(!level) level = 0;

	      //The padding given at the beginning of the line.
	      var level_padding = "";
	      for(var j=0;j<level+1;j++) level_padding += "    ";

	      if(typeof(arr) == 'object') { //Array/Hashes/Objects
		      for(var item in arr) {
			      var value = arr[item];

			      if(typeof(value) == 'object') { //If it is an array,
				      dumped_text += level_padding + "'" + item + "' ...\n";
				      dumped_text += dump(value,level+1);
			      } else {
				      dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
			      }
		      }
	      } else { //Stings/Chars/Numbers etc.
		      dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
	      }
	      return dumped_text;
      }

var msgAttacherGrid = $("#message_attacher_grid"), msgsTotal = $("#selected_messages_number");
var lastLoadedMessages = [];
var onceOpenedMessages = [];
var selectedMessages   = {};
var selectedFolder     = {};

function adaptOffline( data )
{
    if( preferences.use_local_messages == 1 || expresso_offline )
    {
	var folders = expresso_local_messages.list_local_folders();
	
	var stripParents = /^(.*)\/([^\/]*)/;

	$.each( folders, function( i, folder ){
		
		  if(typeof(folder) == 'undefined')  return;
		  
	      var id = 'local_messages/' + folder[0];

	      var parts = stripParents.exec( id );
	  
	      data[data.length] = { 'id' : id,
				    'commonName' : parts[2],
				    'parentFolder' : parts[1] };
	});
    }

    return( data );
}

/* --- jQuery handlers --- */

jQuery('#buttons-container .button').button();

jQuery.ajax({
	url: BASE_PATH + "REST.php?q=folder",
	dataType: 'json',

	success: function( data ){

		data = adaptOffline( data );

		var tree1 = new Array();
		var tree2 = new Array();
		var tree3 = new Array();
		for (var i=0; i<data.length; i++) {

			if (/^INBOX/.test(data[i].id)) {
				if (!unorphanize(tree1, data[i])) {
					data[i].children = new Array();
					tree1.push(data[i]);
				}
			}
			else if (/^user/.test(data[i].id)) {
				if (!unorphanize(tree2, data[i])) {
					data[i].children = new Array();
					tree2.push(data[i]);
				}
			}
			else if (/^local_messages/.test(data[i].id)) {
				if (!unorphanize(tree3, data[i])) {
					data[i].children = new Array();
					tree3.push(data[i]);
				}
			}
			
		}

		var firstFolder = jQuery("#foldertree-container")
		.removeClass('empty-conteiner')
		.html(BASE_PATH + 'app/templates/foldertree.ejs', {folders: [tree1, tree2, tree3]})
		.find("#foldertree").treeview()
		.click(function(event){
			//request new selected folder messages
			var target = $(event.target);

			if( target.is('.collapsable-hitarea, .expandable-hitarea, .lastCollapsable, .lastExpandable, .treeview') )
			    return;

			if( !target.attr('id') )
			    target = target.parent();

            if (target.attr('id') == "foldertree") return;
			
			var targetId = target.attr('id');
			var child = target.find('.folder');
              
			$('.filetree span.folder.selected').removeClass('selected');
			if(!target.is('#foldertree > .expandable, #foldertree > .collapsable'))
				$(target).children('.folder').addClass('selected');
			
			selectedFolder = {
			    id: targetId, 
			    name: child.attr('title'),
			    class: child.attr('class')
			};

			var grid = $("#message_attacher_grid"), offlineCase = "";
			
			if( !targetId.indexOf( 'local_messages/' ) )
			    offlineCase = ":offline";
			

			grid.jqGrid('setGridParam',{url:BASE_PATH + 'REST.php'+offlineCase+'?q=folder/'+targetId.replace(dashes, '.')+'/message'})
			    .trigger("reloadGrid")
			    .jqGrid('setCaption', '<span class="'+child.attr('class')+'">'+child.attr('title')+'</span>');
		})
		.find('span:first-child');

		selectedFolder = {
			id: firstFolder.parent().attr('id'), 
			name: firstFolder.attr('title'),
			class: firstFolder.attr('class')
		};

		//jqgrid
		jQuery("#mailgrid-container")
		.removeClass('empty-conteiner')
		.html(BASE_PATH + 'app/templates/messagegrid.ejs', {data: {}})
		.find("#message_attacher_grid")
		.jqGrid({
			url:BASE_PATH + 'REST.php?q=folder/INBOX/message',
			datatype: "json",
			mtype: 'GET',
			colNames:['#', ' ', 'De', 'Assunto', 'Data', 'Tamanho'],
			colModel:[
				{name:'msg_number',index:'msg_number', width:45, hidden:true, sortable:false},
				{name:'flags',index:'msg_number', width:40, sortable:false, formatter:flags2Class},
				{name:'from.name',index:'msg_number', width:130, sortable:false},
				{name:'subject',index:'subject', width:250, sortable:false},
				{name:'timestamp',index:'timestamp', width:65, align:"center", sortable:false, formatter:date2Time},
				{name:'size',index:'size', width:50, align:"right", sortable:false, formatter:bytes2Size}
			],
			jsonReader : {
				  root:"rows",
				  page: "page",
				  total: "total",
				  records: "records",
				  repeatitems: false,
				  id: "0"
			},
			rowNum:10,
			rowList:[10,25,50],
			pager: '#message_attacher_grid_pager',
			sortname: 'id',
			viewrecords: true,
			sortorder: "desc",
			multiselect: true,
			autowidth: true,
			loadComplete: function(data) {
				lastLoadedMessages = data.rows;
				
				// aplica o contador
				jQuery('.timable').each(function (i) {
					jQuery(this).countdown({
						since: new Date(parseInt(this.title)), 
						significant: 1,
						layout: 'h&aacute; {d<}{dn} {dl} {d>}{h<}{hn} {hl} {h>}{m<}{mn} {ml} {m>}{s<}{sn} {sl}{s>}', 
						description: ' atr&aacute;s'
					});
				});

				// reconstri a seleo das mensagens mesmo depois da mudana de pasta
				if (selectedMessages[selectedFolder.id]) {
					for (var message in selectedMessages[selectedFolder.id]){
						for (var j=0; j<data.rows.length; j++){	
							if (selectedMessages[selectedFolder.id][message] && message == data.rows[j].msg_number) {
								jQuery("#message_attacher_grid").setSelection(jQuery("#message_attacher_grid").getDataIDs()[j], false);
							}
						}
					}
				}
				$('#cb_message_attacher_grid').css('display', 'none');
				
			},
			onSelectRow: function (id, selected) {
				if (selected) {	
					var message = false;
					for (var i=0; i<lastLoadedMessages.length; i++){
						if (lastLoadedMessages[i].msg_number == id) {
							message = lastLoadedMessages[i];
							break;
						}
					}
					
					if (onceOpenedMessages[selectedFolder.id] && onceOpenedMessages[selectedFolder.id][message.msg_number]) {
						if (!selectedMessages[selectedFolder.id])
							selectedMessages[selectedFolder.id] = {};
							
						selectedMessages[selectedFolder.id][message.msg_number] = true;
						$('#mailpreview-container').removeClass('empty-conteiner').html(onceOpenedMessages[selectedFolder.id][message.msg_number].body);
					} else {
						jQuery('#mailpreview-container').block({  
							message: '<div id="loading-content"><div class="image"> </div></div>',  
							css: {  
								backgroundImage: 'url('+BASE_PATH+'modules/attach_message/images/loading.gif)',  
								backgroundRepeat: 'no-repeat', 
								backgroundPosition: 'center', 
								backgroundColor: 'transparent', 
								width: '32px', 
								height: '32px', 
								border:'none'  
							}, 
							overlayCSS: {  
								backgroundColor: '#CCC',  
								opacity:         0.5 
							}  
						}); 

						var offlineCase = "";
					  
						if( !selectedFolder.id.indexOf( 'local_messages/' ) )
						    offlineCase = ":offline";
					  
						if (!selectedMessages[selectedFolder.id])
							selectedMessages[selectedFolder.id] = {};
						selectedMessages[selectedFolder.id][message.msg_number] = true;
						
						$.ajax({
							accepts: 'text/html',
							url: BASE_PATH + 'REST.php'+offlineCase+'?q=folder/'+selectedFolder.id.replace('/', '.')+'/message/'+id,
							dataType: 'json',
							success: function( mail_preview ){
								if (!onceOpenedMessages[selectedFolder.id])
									onceOpenedMessages[selectedFolder.id] = {};
									
								onceOpenedMessages[selectedFolder.id][message.msg_number] = jQuery.extend(true, message, mail_preview);
						
								$('#mailpreview-container').removeClass('empty-conteiner').unblock()
								.find('.message')
								.html(onceOpenedMessages[selectedFolder.id][message.msg_number].body).end()
								.find('#mailpreview-message-info').html(onceOpenedMessages[selectedFolder.id][message.msg_number].subject);
								
								selectedMessagesCount();
							}
						});
					}
				} else {
					selectedMessages[selectedFolder.id][id] = false;
				}
				selectedMessagesCount();
			},
			caption: '<span class="'+selectedFolder.class+'">'+selectedFolder.name+'</span>'
		});
		//.jqGrid('navGrid','#message_attacher_grid_pager',{edit:false,add:false,del:false});
	}
});